import es, gamethread, playerlib, popuplib, effectlib, os, math, random, usermsg, sys, langlib

# For some reason, this is crashing server on load via autoexec.cfg
'''
try:
	import spe
except ImportError:
	spe = None
'''
spe = None

### Globals ###

info = es.AddonInfo() 
info['name']        = "Hosties" 
info['version']     = "3.0.2" 
info['author']      = "Bonbon AKA: Bonbon367" 
info['url']         = "http://addons.eventscripts.com/addons/view/hosties" 
info['description'] = "Hosties Server Control by Bonbon, Original script by STK#Sebastian"

es.ServerVar('hosties_version', info['version'], info['description']).makepublic()
menu_lang = 'en'

sv_options = {
	'hosties_min_players_for_lr': 2,
	'hosties_announce_rebel_killed': 1,
	'hosties_announce_turn_into_rebel': 1,
	'hosties_max_innocent_kills_per_3_seconds': 3,
	'hosties_too_high_kps_punishment': 'kick',
	'hosties_unrestricted_ct_weapons': 'm4a1,deagle,famas,aug,tmp,knife,vesthelm,vest,nvgs',
	'hosties_unrestricted_t_weapons': 'm4a1,deagle,famas,aug,tmp,knife,vesthelm,vest,nvgs',
	'hosties_t_start_weapons': 'deagle,knife',
	'hosties_ct_start_weapons': 'deagle,m4a1',
	'hosties_beacon_on_lr': 1,
	'hosties_allow_to_kill_for_jumping_on_head': 1,
	'hosties_strip_weapons_on_round_end': 0,
	'hosties_rebel_color': '255,0,0,255',
	'hosties_announce_lr_available': 0,
	'hosties_announce_ct_hurt_t': 0,
	'hosties_rebel_on_hurt': 0,
	'hosties_show_rules_on_join': 1,
	'hosties_end_round_at_round_end_time': 1,
	'hosties_change_lr_colors': 0,
	'hosties_round_swap_teams': 0,
	'hosties_teleport_to_designated_areas_for_lr': 1,
	'hosties_enabled_lrs': 'Race,CF,KF,S4S,GT',
	'hosties_make_ct_accept_lr_with_rebel': 1,
	'hosties_silent_commands': 1,
	'hosties_stop_double_drop': 1,
	'hosties_commands': '!lr,!rules,!checkplayers,!commands,!hosties,!control,!checkguns,!wspoint,!setpoints',
	'hosties_enable_chicken_fight_won': 1,
	'hosties_control_command_time': 10,
	'hosties_controller_color': '255,128,0,0',
	'hosties_simon_says_completed_color': '255,0,255,0',
	'hosties_max_more_cts': 2,
	'hosties_control_allow_simon': 1,
	'hosties_enable_control': 1,
	'hosties_enable_noblock': 1,
	'hosties_menu_lang': 'en',
	'hosties_must_accept_lr': 0,
	'hosties_warning_weapon': 'weapon_p228',
	'hosties_warning_weapon_damage': 1,
	'hosties_lr_required_ts': 3,
	'hosties_warning_damage_regenerate': 0,
	'hosties_enable_s4s_single_shot': 1,
	'hosties_announce_attacked_with_gun': 1,
	'hosties_stop_kf_shoot': 1,
	'hosties_t_to_ct_ratio': 0,
	'hosties_noblock_on_round_start': 0,
}

mapcoords = reload(__import__('hosties.mapcoords')).mapcoords
sv = es.ServerVar

### Constants ###

FILEPATH = es.getAddonPath('hosties') + '/'
HOSTIES = sys.modules['hosties.hosties']
HASEST = not str(es.ServerVar('est_version')) == '0'

EVENTS = [
    'player_' + x for x in ['hurt', 'activate', 'disconnect', 'death', 'shoot', 'connect', 'falldamage', 'blind', 
    'jump']] + ['bomb_' + x for x in ['planted', 'beingplant', 'defused', 'begindefuse', 'explode']] + ['es_map_start',
    'hegrenade_detonate', 'flashbang_detonate', 'smokegrenade_detonate', 'grenade_bounce', 'weapon_fire', 'round_start', 
    'round_end', 'es_player_validated', 'item_pickup'
]

WEAPONTYPES = {
	'pistols': 'glock,usp,p228,fiveseven,deagle,elite',
	'smgs': 'mac10,ump45,p90,mp5navy,tmp',
	'shotguns': 'm3,xm1014',
	'rifles': 'famas,aug,m4a1,sg552,ak47,galil',
	'snipers': 'sg550,awp,scout,g3sg1',
	'machineguns': 'm249',
	'c4': 'c4',
	'grenades': 'flashbang,hegrenade,smokegrenade',
	'knife': 'knife',
	'armor': 'vesthelm,vest,defuser'
}

### Loads ###

text = langlib.Strings(FILEPATH + 'hosties.ini')
def load():
	global menu_lang, HOSTIES
	if not es.exists('command', 'hosties_rule'):
		es.regcmd('hosties_rule', 'hosties/hosties_rule')

	if not es.exists('command', 'hosties_addpunishment'):
		es.regcmd('hosties_addpunishment', 'hosties/hosties_addpun')

	if not es.exists('command', 'hosties_add_menu_punishment'):
		es.regcmd('hosties_add_menu_punishment', 'hosties/add_menu_punishment')

	if not es.exists('command', 'hosties_load'):
		es.regcmd('hosties_load', 'hosties/hosties_load')

	if not es.exists('command', 'hosties_unload'):
		es.regcmd('hosties_unload', 'hosties/hosties_unload')

	if not es.exists('command', 'hosties_reload'):
		es.regcmd('hosties_reload', 'hosties/hosties_reload')

	for option in sv_options:
		sv(option).set(sv_options[option])

	if os.path.isfile(FILEPATH + 'hosties.cfg'):
		es.server.cmd('es_xmexec ../addons/eventscripts/hosties/hosties.cfg')
	menu_lang = str(sv('hosties_menu_lang'))

	hosties_menu = popuplib.easymenu('Hosties', '_popup_choice', hosties_select)
	hosties_menu.addoption('Rules', 'Rules')
	hosties_menu.addoption('Commands', 'Commands')

	if int(sv('hosties_silent_commands')):
		for command in ['hosties', 'control', 'checkplayers', 'commands', 'lr', 'checkguns']:
			if not es.exists('saycommand', '!' + command):
				es.regsaycmd('!' + command, 'hosties/say_command')
			HM.registerCommand(command, command + ' command') 

	if not str(sv('eventscripts_currentmap')) == '0':
		for sound in ['crouch.mp3', 'rotate.mp3', 'jump.mp3', 'simon_says.mp3']:
			es.stringtable('downloadables', 'sound/hosties/' + sound)

	for userid in es.getUseridList():
		HM.getPlayer(userid)
		Rb.iks[userid] = {}

	CTRL.issueMenu.settitle(text('Issue Command', {}, menu_lang))
	CTRL.controlMenu.settitle(text('control', {}, menu_lang))

	es.flags('remove', 'cheat', 'endround')
	EH.registerEvents()

	HOSTIES = sys.modules['hosties.hosties']

def unload():
	EH.unregisterEvents()
	es.addons.unregisterClientCommandFilter(_restrict_weapons)

	for request in LRM.filters['client']:
		es.addons.unregisterClientCommandFilter(request)

	for request in LRM.filters['say']:
		es.addons.unregisterSayFilter(request)

	for request in LRM.funcs:
		del sys.modules['hosties.lastrequests.%s'%request]

	for command in LRM.commands.keys() + ['hosties', 'control', 'checkplayers', 'commands', 'lr', 'checkguns']:
		if es.exists('saycommand', command):
			es.unregsaycmd(command)

	for delay in ['beacon players', 'play sound', 'control time up', 'spin check', 'crouch check', 'regen lost', 'unblock']:
		gamethread.cancelDelayed(delay)

### Classes ###

class HostiesPlayer(object):
	def __init__(self, userid):
		self.pd = {}
		self.lang = playerlib.getPlayer(userid).get('lang')
		self.userid = userid

	def checkKill(self, userid, weapon=None):
		Rb.player_death(int(userid), self.userid, weapon, False)

	def makeRebel(self, message=True):
		Rb.makeRebel(self.userid, message)

	def tell(self, langlib_key, langlib_args={}):
		es.tell(self.userid, '#multi', text(langlib_key, langlib_args, self.lang))

	def send(self, menu):
		if es.getplayersteamid(self.userid) == 'BOT':
			return

		if popuplib.active(self.userid)['count'] > 3:
			self.tell('too many menus')
			return
		popuplib.send(menu, self.userid)

	def changeTeam(self, team):
		if spe:
			spe.Call('ChangeTeam', spe.getPlayer(self.userid), team)
			return

		if HASEST:
			es.server.queuecmd('est_team %s %s'%(self.userid, team))
			return
		es.changeteam(self.userid, team)

class Hosties(object):
	def __init__(self):
		self.players = {}

		self.rules = []
		self.ruleMenu = popuplib.easymenu('Rules', '_popup_choice', self.ruleSelect)

		self.commands = {}
		self.commandMenu = popuplib.easymenu('Commands', '_popup_choice', self.commandSelect)

		self.punishments = {}

	def registerCommand(self, command, langlib_string):
		if command in self.commands:
			return

		self.commands[command] = text(langlib_string, {}, str(sv('hosties_menu_lang')))
		self.commandMenu.addoption(command, command)

	def unregisterCommand(self, command):
		if not command in self.commands:
			return

		del self.commands[command]
		self.commandMenu = popuplib.easymenu('Commands', '_popup_choice', self.commandSelect)

		for command in self.commands:
			self.commandMenu.addoption(command, command)

	def addRule(self, rule):
		if rule in self.rules:
			es.dbgmsg(0, 'Hosties Error: Rule already exists!')
			return

		self.rules.append(rule)
		self.ruleMenu.addoption(rule, rule)

	def commandSelect(self, userid, choice, popupid):
		es.tell(userid, '#multi', self.commands[choice])

	def ruleSelect(self, userid, choice, popupid):
		getPlayer(userid).send('Rules')

	def getPlayer(self, userid):
		userid = int(userid)
		if not userid in self.players:
			self.players[userid] = HostiesPlayer(userid)
		return self.players[userid]

	def delPlayer(self, userid):
		userid = int(userid)
		if not userid in self.players:
			return

		if userid in [LR.t, LR.ct]:
			LR.stopLR(None, None)
		del self.players[userid]

	def msg(self, langlib_key, langlib_args={}):
		for userid in es.getUseridList():
			es.tell(userid, '#multi', text(langlib_key, langlib_args, self.getPlayer(userid).lang))

	def unBlockPlayers(self, players=None):
		alive = players
		if not players:
			alive = playerlib.getUseridList('#alive')

		for userid in alive:
			temp = True
			for userid2 in alive:
				if userid2 == userid:
					continue

				x, y, z = es.getplayerlocation(userid)
				x2, y2, z2 = es.getplayerlocation(userid2)

				if (((x - x2) ** 2) + ((y - y2) ** 2)) ** 0.5 <= 30:
					es.setplayerprop(userid, 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', ','.join([str(random.randint(-255, 255)) for x in '123']))
					es.setplayerprop(userid2, 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', ','.join([str(random.randint(-255, 255)) for x in '123']))
					temp = False
					break

			if temp:
				alive.remove(userid)
				es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 5)

		if alive:
			gamethread.delayedname(0.5, 'unblock', self.unBlockPlayers, alive)

	@staticmethod
	def isRestricted(weapon, team):
		try:
			weapon_type = filter(lambda x: weapon in WEAPONTYPES[x], WEAPONTYPES.keys())[0]
		except IndexError:
			es.msg('#multi', '#lightgreen[Hosties]: ERROR:#default Did not find weapon "%s", please post this message at http://forums.mattie.info/cs/forums/viewtopic.php?t=25870'%weapon)
			return
		unrestricted_weapons = (str(sv('hosties_unrestricted_ct_weapons')) if team == 3 else str(sv('hosties_unrestricted_t_weapons'))).lower().split(',')

		for uweapon in unrestricted_weapons:
			if weapon == uweapon:
				return False

			if weapon_type in uweapon:
				if '!' in uweapon:
					not_weapons = uweapon.split('!')[1].split('&')
					if weapon in not_weapons:
						return True
				return False
		return True

HM = Hosties()

class LastRequest(object):
	def __init__(self):
		self.t = None
		self.ct = None
		self.lrwinner = None
		self.lrloser = None
		self.beaconed = False

		self.lastrequest = False
		self.accepted = []

		self.lrMenu = popuplib.easymenu('Last Request', '_popup_choice', self.lrSelect)

	def lrSelect(self, userid, choice, popupid):
		if self.canLR(userid):
			choosePlayer = popuplib.easymenu('Choose Player', '_popup_choice', self.choosePlayerSelect)
			for userid2 in playerlib.getUseridList('#ct,#alive'):
				choosePlayer.addoption([choice, userid2], es.getplayername(userid2))
			getPlayer(userid).send('Choose Player')

	def alrSelect(self, userid, choice, popupid):
		if choice[2] == 'Yes':
			if choice[0] in Rb.rebels:
				Rb.rebels.remove(choice[0])

			self.accepted.append(choice[0])
			self.choosePlayerSelect(choice[0], [choice[1], userid], None)
			self.accepted.remove(choice[0])
			return

		es.tell(choice[0], '#multi', text('declined request', {'player': es.getplayername(userid)}, playerlib.getPlayer(choice[0]).get('lang')))

	def choosePlayerSelect(self, userid, choice, popupid):
		if self.canLR(userid):
			if not choice[0] in LRM.rfuncs or not 'start' in LRM.rfuncs[choice[0]]:
				es.msg('#multi', '#lightgreen[Hosties]: #defaultERROR: No initiate function for %s!'%choice[0])
				return

			if not es.exists('userid', choice[1]):
				es.tell(userid, text('target left server', {}, playerlib.getPlayer(userid).get('lang')))
				return

			if playerlib.getPlayer(choice[1]).get('isdead'):
				es.tell(userid, '#multi', text('target dead', {}, playerlib.getPlayer(userid).get('lang')))
				return

			ma = False
			if int(sv('hosties_must_accept_lr')) and not userid in self.accepted:
				ma = True

			if not userid in Rb.rebels or not int(sv('hosties_make_ct_accept_lr_with_rebel')) and not ma:
				self.t = userid
				self.ct = choice[1]
				self.lastrequest = choice[0]

				if int(sv('hosties_beacon_on_lr')):
					self.beaconPlayers()
				LRM.rfuncs[self.lastrequest]['start'](self.t, self.ct)

				if int(sv('hosties_change_lr_colors')):
					playerlib.getPlayer(userid).set('color', [255, 0, 0, 255])
					playerlib.getPlayer(choice[1]).set('color', [0, 0, 255, 255])
				return

			alr = popuplib.easymenu('Accept LR', '_popup_choice', self.alrSelect)
			alr.addoption([userid, choice[0], 'Yes'], text('yes', {}, menu_lang))
			alr.addoption([userid, choice[0], 'No'], text('no', {}, menu_lang))

			es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultasking #lightgreen%s#default to accept your Last Request...'%es.getplayername(choice[1]))
			es.tell(choice[1], '#multi', text('marked as rebel' if not ma else 'accept lr', {'player': es.getplayername(userid)}, playerlib.getPlayer(choice[1]).get('lang')))
			getPlayer(choice[1]).send('Accept LR')

	def canLR(self, userid, ip=False):
		if playerlib.getPlayer(userid).get('isdead'):
			es.tell(userid, '#multi', text('must be alive', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if not es.getplayerteam(userid) == 2:
			es.tell(userid, '#multi', text('must be terrorist', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if not len(playerlib.getPlayerList('#t,#alive')) <= int(sv('hosties_min_players_for_lr')):
			es.tell(userid, '#multi', text('too many ts', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if self.lastrequest and not ip:
			es.tell(userid, '#multi', text('lr in progress', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if es.getplayercount(2) < int(sv('hosties_lr_required_ts')):
			es.tell(userid, '#multi', text('not enough ts', {}, playerlib.getPlayer(userid).get('lang')))
			return
		return True

	def initiateRequest(self, userid):
		if self.canLR(userid):
			self.lrMenu = popuplib.easymenu('Last Request', '_popup_choice', self.lrSelect)
			for request in LRM.funcs:
				self.lrMenu.addoption(request, text(request, {}, menu_lang))
			getPlayer(userid).send('Last Request')

	def beaconPlayers(self):
		if not self.lastrequest:
			return

		if not HASEST and not self.beaconed:
			self.beaconed = True
			es.server.queuecmd('ma_beacon %s 1'%self.ct)
			es.server.queuecmd('ma_beacon %s 1'%self.t)

		for userid in [self.t, self.ct]:
			x, y, z = es.getplayerlocation(userid)
			es.server.queuecmd('est_effect 10 #a 0 "sprites/lgtning.vmt" %s %s %s 20 300 0.2 20 10 0 255 0 0 255 30'%(x, y, z))
			es.server.queuecmd('est_effect 10 #a 0.1 "sprites/lgtning.vmt" %s %s %s 20 300 0.3 15 10 0 255 150 150 255 30'%(x, y, z))
			es.emitsound('player', userid, 'buttons/blip2.wav', 0.8, 0.6)

		gamethread.cancelDelayed('beacon players')
		gamethread.delayedname(1, 'beacon players', self.beaconPlayers)

	def stopLR(self, winner, messagekey, messageargs={}):
		self.beaconed = False
		if not HASEST:
			es.server.queuecmd('ma_beacon %s 0;ma_beacon %s 0'%(self.t, self.ct))

		if not self.lastrequest:
			self.lrwinner = None
			self.lrloser = None
			return

		if messagekey:
			HM.msg(messagekey, messageargs)

		if winner:
			self.lrwinner = winner
			self.lrloser = self.t if winner == self.ct else self.ct

		for userid in [self.t, self.ct]:
			if not userid:
				continue

			if not es.exists('userid', userid):
				continue
			playerlib.getPlayer(userid).set('color', [255, 255, 255, 255])

		self.t = None
		self.ct = None

		if 'end' in LRM.rfuncs[self.lastrequest]:
			LRM.rfuncs[self.lastrequest]['end']()
		self.lastrequest = False

	def playerDeath(self, userid):
		if not userid in [self.t, self.ct] or not self.lastrequest:
			return
		self.stopLR(None, None)

LR = LastRequest()

class LastRequestManager(object):
	def __init__(self):
		self.funcs = {}
		self.rfuncs = {}
		self.commands = {}
		self.overrides = {}

		self.filters = {'client': {}, 'say': {}}

	def removePYC(self, request):
		if os.path.isfile(FILEPATH + '/lastrequests/%s.pyc'%request):
			os.remove(FILEPATH + 'lastrequests/%s.pyc'%request)

	def loadLastRequest(self, request):
		if request in self.funcs:
			es.dbgmsg(0, 'Hosties Error: %s is already loaded!'%request)
			return

		if not os.path.isfile(FILEPATH + '/lastrequests/%s.py'%request):
			es.dbgmsg(0, 'Hosties Error: No %s.py under ./cstrike/addons/eventscripts/hosties/lastrequests !'%request)
			return

		self.funcs[request] = None
		if 'hosties.lastrequests.%s'%request in sys.modules:
			del sys.modules['hosties.lastrequests.%s'%request]
			self.removePYC(request)

		self.funcs[request] = reload(__import__('hosties.lastrequests.%s'%request, fromlist=['hosties', 'lastrequests']))
		es.dbgmsg(0, 'Hosties: Loaded %s'%request)

	def unloadLastRequest(self, request):
		if request == LR.lastrequest:
			es.dbgmsg(0, 'Hosties Error: Cannot unload last request. %s is alread in progress!'%request)
			return

		if not request in self.funcs:
			es.dbgmsg(0, 'Hosties Error: %s isn\'t loaded!'%request)
			return

		if request in self.filters['client']:
			es.addons.unregisterClientCommandFilter(self.filters['client'][request])

		if request in self.filters['say']:
			es.addons.unregisterClientCommandFilter(self.filters['say'][request])

		if hasattr(self.getModule(request), 'unload'):
			getattr(self.getModule(request), 'unload')()

		del self.funcs[request]
		del sys.modules['hosties.lastrequests.%s'%request]

		self.removePYC(request)
		es.dbgmsg(0, 'Hosties: Unloaded %s'%request)

	def reloadLastRequest(self, request):
		gamethread.delayed(0, self.unloadLastRequest, request)
		gamethread.delayed(0, gamethread.delayed(0, self.loadLastRequest, request))

	def getModule(self, request):
		if not request in self.funcs:
			raise ImportError('%s is not loaded!'%request)
		return self.funcs[request]

	def returnClientCommand(self, userid, args):
		request = LR.lastrequest
		if not request:
			return True

		if request in self.filters['client']:
			return self.filters['client'][request](userid, args)
		return True

LRM = LastRequestManager()

class RegisterLastRequest(object):
	def __init__(self, request):
		if not request in LRM.funcs:
			raise AttributeError('no last request %s!'%request)
		self.request = request

	def _checkArgs(self, callback, argcount_check=True):
		if not callable(callback):
			raise TypeError('%s is not callable!'%callback.__class__.__name__)

		if argcount_check:
			if callback.__class__.__name__ == 'function':
				argc = callback.func_code.co_argcount
				if not argc == 2:
					raise TypeError('callback must take exactly 2 args, %s given!'%argc)

			elif callback.__class__.__name__ == 'instancemethod':
				argc = callback.im_func.func_code.co_argcount
				if not argc == 3:
					raise TypeError('callback must take exactly 2 args, %s given!'%argc)

		if not self.request in LRM.rfuncs:
			LRM.rfuncs[self.request] = {}
		return True

	def registerStartFunction(self, callback):
		if not self._checkArgs(callback):
			return
		LRM.rfuncs[self.request]['start'] = callback

	def registerEndFunction(self, callback):
		if not self._checkArgs(callback, False):
			return
		LRM.rfuncs[self.request]['end'] = callback

	def registerSayCommand(self, command, langlib_string, callback):
		if command in LRM.commands:
			return

		if not es.exists('saycommand', command):
			es.regsaycmd(command, 'hosties/lr_command')

		HM.registerCommand(command, langlib_string)
		LRM.commands[command] = callback

	def unregisterSayCommand(self, command):
		if not command in LRM.commands:
			return

		if es.exists('saycommand', command):
			es.unregsaycmd(command)

		HM.unregisterCommand(command)
		del LRM.commands[command]

	def registerOverRide(self, event):
		if not event in LRM.overrides:
			LRM.overrides[event] = []

		if self.request in LRM.overrides[event]:
			return

		LRM.overrides[event].append(self.request)

	def registerClientCommandFilter(self, callback):
		LRM.filters['client'][self.request] = callback

	def __getattr__(self, item):
		if hasattr(LR, item):
			return getattr(LR, item)
		raise AttributeError('LastRequest instance has no attribute %s!'%item)

class EventHandler(object):
	class FireEvent(object):
		def __init__(self, event, exists=True):
			self.event = event
			self.exists = exists

		def __call__(self, ev):
			if self.exists:
				getattr(HOSTIES, self.event)(ev)

			if not LR.lastrequest:
				return

			module = LRM.getModule(LR.lastrequest)
			if hasattr(module, self.event):
				getattr(module, self.event)(ev)

	def registerEvents(self):
		for event in EVENTS:
			if not hasattr(HOSTIES, event):
				es.addons.registerForEvent(HOSTIES, event, self.FireEvent(event, False))
				continue

			es.addons.unregisterForEvent(HOSTIES, event)
			es.addons.registerForEvent(HOSTIES, event, self.FireEvent(event))

	def unregisterEvents(self):
		for event in EVENTS:
			es.addons.unregisterForEvent(HOSTIES, event)

EH = EventHandler()

class Rebel(object):
	def __init__(self):
		self.rebels = []
		self.ik = {}
		self.iks = {}
		self.rebelchange = {}
		self.kps = {}
		self.on_heads = {}
		self.pfk = {}
		self.trounds = {}

	def makeRebel(self, userid, message=True):
		self.rebels.append(userid)
		playerlib.getPlayer(userid).set('color', str(sv('hosties_rebel_color')).split(','))

		if int(sv('hosties_announce_turn_into_rebel')) and message:
			HM.msg('rebel', {'player': es.getplayername(userid)})

		if not str(sv('hosties_rebel_color')) == '0':
			playerlib.getPlayer(userid).set('color', str(sv('hosties_rebel_color')).split(','))

		if LR.lastrequest and userid == LR.t:
			LR.stopLR(None, None)

	def player_death(self, userid, attacker, weapon, override=True):
		if userid == attacker:
			return

		if userid == LR.lrloser and attacker == LR.lrwinner:
			LR.lrwinner = None
			LR.lrloser = None
			return

		tokens = {'t': es.getplayername(attacker if es.getplayerteam(attacker) == 2 else userid), 'ct': es.getplayername(attacker if es.getplayerteam(attacker) == 3 else userid), 'player': es.getplayername(attacker)}
		if LR.lastrequest and override:
			return

		if es.getplayerteam(attacker) == 2:
			if attacker in self.rebels:
				return

			if attacker in self.on_heads:
				if self.on_heads[attacker] == userid:
					del self.on_heads[attacker]
					if weapon == 'knife':
						for userid2 in es.getUseridList():
							lang = playerlib.getPlayer(userid2).get('lang')
							es.tell(userid2, '#multi', text('killed for head1', tokens, lang))
							es.tell(userid2, '#multi', text('killed for head2', tokens, lang))
						return
			self.makeRebel(attacker)

		if userid in self.rebels:
			HM.msg('killed a rebel', {'ct': es.getplayername(attacker)})
			return

		# Doesn't work, weapon is returned as 0 because they're dead.
		if self.check_rebel(userid):
			if int(sv('hosties_announce_rebel_killed')):
				HM.msg('killed with gun', tokens)
				return

		if not userid in self.rebels:
			if es.getplayerteam(attacker) == 3:
				if attacker == LR.lrwinner:
					LR.lrwinner = None
					return
				self.ik[attacker] = self.ik[attacker] + 1 if attacker in self.ik else 1

				if self.ik[attacker] in self.pfk:
					self.punish(attacker, self.pfk[self.ik[attacker]])
				self.kps[attacker] = self.kps[attacker] + 1 if attacker in self.kps else 1
				gamethread.delayed(1.5, self.make_0, attacker)

				if self.kps[attacker] >= int(sv('hosties_max_innocent_kills_per_3_seconds')):
					self.punish(attacker, str(sv('hosties_too_high_kps_punishment')))
				self.iks[attacker][userid] = self.iks[attacker][userid] + 1 if userid in self.iks[attacker] else 1

				if self.iks[attacker][userid] in HM.punishments:
					pmenu = popuplib.easymenu('Punishment Menu', '_popup_choice', pmenu_select)
					pmenu.settitle(text('Punishment Menu', {}, menu_lang))
					for option in HM.punishments[self.iks[attacker][userid]].split(','):
						pmenu.addoption([attacker, option], option)
					getPlayer(userid).send('Punishment Menu')

		elif es.getplayerteam(attacker) == 3:
			self.iks[attacker][userid] = 0

	def check_dead(self, userid):
		if not playerlib.getPlayer(userid).get('isdead'):
			es.server.queuecmd('damage %s 32 2'%userid)

	def punish(self, userid, o):
		o = o.replace('\r', '')
		if o == 'slay':
			playerlib.getPlayer(userid).set('health', 1)
			es.server.queuecmd('es_xfire %s !self ignite')
			gamethread.delayed(0.1, self.check_dead, userid)

		elif o == 'kick':
			es.server.queuecmd('kickid %s Don\'t line up and kill hosties!'%userid)
			tokens = {'player': es.getplayername(userid), 'steamid': es.getplayersteamid(userid), 'ip': playerlib.getPlayer(userid).get('ip')}
			for userid2 in es.getUseridList():
				es.tell(userid2, '#multi', text('line up kick', tokens, playerlib.getPlayer(userid2).get('lang')))
			return

		elif o.startswith('takehp'):
			playerlib.getPlayer(userid).set('health', max(playerlib.getPlayer(userid).get('health') - int(o[6:]), 1))

		elif o == 'stripweapons':
			es.server.queuecmd('es_xgive %s player_weaponstrip'%userid)
			es.server.queuecmd('es_fire %s player_weaponstrip strip'%userid)
			es.server.queuecmd('es_fire %s player_weaponstrip kill'%userid)

		elif o.startswith('maket'):
			self.trounds[es.getplayersteamid(userid)] = int(o[5:])
			getPlayer(userid).changeTeam(2)
			es.tell(userid, '#multi', text('rounds as t', {'rounds': o[5:]}, playerlib.getPlayer(userid).get('lang')))

		elif o.startswith('ban'):
			es.server.queuecmd('banid %s %s'%(o[3:], es.getplayersteamid(userid)))
			es.server.queuecmd('writeid')
			es.server.queuecmd('kickid %s You have been banned for %s minutes for lining up and killing hosties!'%(userid, o[3:]))
		es.tell(userid, '#multi', text('dont kill innocent', {}, playerlib.getPlayer(userid).get('lang')))

	def make_0(self, userid):
		self.kps[userid] = 0

	def check_rebel(self, userid):
		if es.getplayerteam(userid) == 2:
			if not str(playerlib.getPlayer(userid).get('primary')) == '0':
				return True

			if not str(playerlib.getPlayer(userid).get('secondary')) == '0':
				return True
		return False

	def check_on_head(self, userid):
		if int(sv('hosties_allow_to_kill_for_jumping_on_head')):
			if es.getplayerteam(userid) == 3:
				for userid2 in playerlib.getUseridList('#t,#alive'):
					if playerlib.getPlayer(userid).get('distance', [userid2, 'xy']) <= 40 and 180 >= playerlib.getPlayer(userid).get('distance', [userid2, 'z']) >= 60:
						self.on_heads[userid2] = userid
						break

	def add_punishment(self, args):
		if not args[0].isdigit():
			es.dbgmsg(0, 'Invalid amount of kills for hosties_addpunishment!')
			return

		if int(args[0]) in self.pfk:
			es.dbgmsg(0, 'Already a punishment for %s kills!'%args[0])
			return

		self.pfk[int(args[0])] = args[1]

Rb = Rebel()

class Control(object):

	def __init__(self):
		self.controller = None
		self.pd = {}
		self.say_times = {'rotate': 2, 'simon_says': 1, 'jump': 1, 'crouch': 1}
		self.is_order = False
		self.simon_says = False

		self.issueMenu = popuplib.easymenu('Issue Command', '_popup_choice', self.issueSelect)
		for option in ['Rotate 180 Degrees', 'Jump', 'Crouch', 'Crouch Jump']:
			self.issueMenu.addoption(option, text(option, {}, menu_lang))

		self.controlMenu = popuplib.easymenu('Control', '_popup_choice', self.controlSelect)

		for option in ['Become Controller', 'Stop Controlling', 'Issue Command']:
			self.controlMenu.addoption(option, text(option, {}, menu_lang))

	def controlSelect(self, userid, choice, popupid):
		if choice == 'Issue Command':
			if not userid == CTRL.controller:
				es.tell(userid, '#multi', text('not controller', {}, playerlib.getPlayer(userid).get('lang')))
				return
			getPlayer(userid).send('Issue Command')

		elif choice == 'Become Controller':
			CTRL.take_control(userid)

		elif choice == 'Stop Controlling':
			CTRL.stop_control(userid)

	def issueSelect(self, userid, choice, popupid):
		issueMenu2 = popuplib.easymenu('Simon Says', '_popup_choice', self.issueSelect2)
		if int(sv('hosties_control_allow_simon')):
			issue2_menu.addoption([choice, 'With Simon'], text('With Simon', {}, menu_lang))

		issueMenu2.addoption([choice, 'Without Simon'], text('Without Simon', {}, menu_lang))
		getPlayer(userid).send('Simon Says')

	def issueSelect2(self, userid, choice, popupid):
		self.issueOrder(userid, choice[0], (True if choice[1] == 'With Simon' else False))

	def take_control(self, userid):
		if self.controller:
			es.tell(userid, '#multi', text('already controller', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if not es.getplayerteam(userid) == 3:
			es.tell(userid, '#multi', text('must be ct', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if playerlib.getPlayer(userid).get('isdead'):
			es.tell(userid, '#multi', text('must be alive', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if LR.lastrequest:
			es.tell(userid, '#multi', text('no control during lr', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if not len(filter(lambda x: x not in Rb.rebels, playerlib.getUseridList('#t,#alive'))):
			es.tell(userid, '#multi', text('no non rebellers', {}, playerlib.getPlayer(userid).get('lang')))
			return

		self.controller = userid
		playerlib.getPlayer(userid).set('color', str(sv('hosties_controller_color')).split(','))

		for userid2 in es.getUseridList():
			es.tell(userid, '#multi', text('now controller', {'player': es.getplayername(userid)}, playerlib.getPlayer(userid2).get('lang')))

	def stop_control(self, userid):
		if not self.controller == userid:
			es.tell(userid, '#multi', text('not controller', {}, playerlib.getPlayer(userid).get('lang')))
			return

		self.stop_controlling()
		for userid2 in es.getUseridList():
			es.tell(userid2, '#multi', text('no longer controller', {'player': es.getplayername(userid)}, playerlib.getPlayer(userid2).get('lang')))

	def issueOrder(self, userid, order, simon_says):
		if not len(filter(lambda x: x not in Rb.rebels, playerlib.getUseridList('#t,#alive'))):
			es.tell(userid, '#multi', text('no non rebellers', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if self.is_order:
			es.tell(userid, '#multi', text('order in progress', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if not userid == self.controller:
			es.tell(userid, '#multi', text('not controller', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if playerlib.getPlayer(userid).get('isdead'):
			es.tell(userid, '#multi', text('must be alive', {}, playerlib.getPlayer(userid).get('lang')))
			return

		sound = ''
		if simon_says:
			sound += 'simon_says,'
		sound += {'Rotate 180 Degrees': 'rotate', 'Jump': 'jump', 'Crouch': 'crouch', 'Crouch Jump': 'crouch,jump'}[order]

		for userid2 in es.getUseridList():
			es.centertell(userid2, sound.replace(',', ' '))
			usermsg.hudhint(userid, sound.replace(',', ' '))

			es.tell(userid, '#multi', '#lightgreen[Hosties]: #default%s'%sound.replace(',', ' '))
			delay = -self.say_times[sound.split(',')[0]]

			for s in sound.split(','):
				delay += self.say_times[s]
				gamethread.delayedname(delay, 'play sound', es.cexec, (userid2, 'play hosties/%s.mp3'%s))

			if es.getplayerteam(userid2) == 2 and not playerlib.getPlayer(userid2).get('isdead'):
				self.pd[userid2] = {'crouched': False, 'spun': False, 'spin_angles': playerlib.getPlayer(userid2).get('viewangle'), 'jumped': False}

		self.simon_says = simon_says
		if simon_says:
			if order == 'Rotate 180 Degrees':
				self.spin_check_loop(int(sv('hosties_control_command_time')))
			elif order == 'Crouch':
				self.crouch_check_loop(int(sv('hosties_control_command_time')))

		self.is_order = order
		gamethread.delayedname(int(sv('hosties_control_command_time')), 'control time up', self.end_order)
		es.msg('#multi', '#lightgreen[Hosties]: #defaultAll terrorists have #lightgreen%s#default seconds to #lightgreen%s!'%(int(sv('hosties_control_command_time')), order))

	def end_order(self):
		gamethread.cancelDelayed('control time up')
		message = 'Order has been finished, everyone that did not finish task has been turned into a rebel!' if self.simon_says else 'Order is finished'
		es.msg('#multi', '#lightgreen[Hosties]: #default' + message)

		if self.simon_says:
			for userid in self.pd:
				playerlib.getPlayer(userid).set('color', [255,255,255,255])
				if not self.pd[userid][{'Rotate 180 Degrees': 'spun', 'Jump': 'jumped', 'Crouch': 'crouched', 'Crouch Jump': 'jumped'}[self.is_order]]:
					es.tell(userid, '#multi', text('now rebel', {}, playerlib.getPlayer(userid).get('lang')), ' for not completing the orders')
					getPlayer(userid).makeRebel(False)

		self.pd.clear()
		self.simon_says = False
		self.is_order = False

	def spin_check_loop(self, time_left):
		time_left -= 0.1
		if time_left >= 0:
			gamethread.delayedname(0.1, 'spin check', self.spin_check_loop, time_left)
			for userid in playerlib.getUseridList('#t,#alive'):
				if userid in self.pd:
					if not userid in Rb.rebels and not self.pd[userid]['spun']:
						x, y, z = playerlib.getPlayer(userid).get('viewangle')
						x2, y2, z2 = self.pd[userid]['spin_angles']

						y = y if y >= 0 else -y + 180
						y2 = y2 if y2 >= 0 else -y + 180

						if 160 <= abs(y - y2) >= 200:
							es.tell(userid, '#multi', text('task completed', {}, playerlib.getPlayer(userid).get('lang')))
							playerlib.getPlayer(userid).set('color', str(sv('hosties_simon_says_completed_color')).split(','))

							self.pd[userid]['spun'] = True
							self.check_over()

	def crouch_check_loop(self, time_left):
		time_left -= 0.1
		if time_left > 0:
			for userid in playerlib.getUseridList('#t,#alive'):
				if not userid in Rb.rebels and not self.pd[userid]['crouched']:
					if es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2:
						playerlib.getPlayer(userid).set('color', str(sv('hosties_simon_says_completed_color')).split(','))
						self.pd[userid]['crouched'] = True
						self.check_over()
			gamethread.delayedname(0.1, 'crouch check', self.crouch_check_loop, time_left)

	def stop_controlling(self):
		if es.exists('userid', self.controller):
			if not playerlib.getPlayer(self.controller).get('isdead'):
				playerlib.getPlayer(self.controller).set('color', [255, 255, 255, 255])

		self.controller = None
		self.is_order = False

		for delay in ['play sound', 'spin check', 'crouch check']:
			gamethread.cancelDelayed(delay)

	def player_jump(self, userid):
		if self.is_order:
			if 'Jump' in self.is_order:
				if es.getplayerteam(userid) == 2:
					if not self.pd[userid]['jumped']:
						if 'Crouch' in self.is_order and not es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2:
							es.tell(userid, '#multi', text('must be crouch jumping', {}, playerlib.getPlayer(userid).get('lang')))
							return
						self.pd[userid]['jumped'] = True
						playerlib.getPlayer(userid).set('color', str(sv('hosties_simon_says_completed_color')).split(','))
						self.check_over()

	def check_over(self):
		if not len(filter(lambda x: not self.pd[x][{'Rotate 180 Degrees': 'spun', 'Jump': 'jumped', 'Crouch': 'crouched', 'Crouch Jump': 'jumped'}[self.is_order]], self.pd.keys())):
			self.end_order()

CTRL = Control()

### Events ###

def player_team(ev):
	userid = ev['userid']
	if ev['es_steamid'] in Rb.trounds:
		if ev['team'] == '3':
			getPlayer(userid).changeTeam(2)
			es.server.queuecmd('es_xsetpos %s '%(userid + '%s %s %s'%return_random_t_spawn()))
			es.tell(userid, '#multi', text('rounds as t', {'rounds': Rb.trounds[ev['es_steamid']]}, playerlib.getPlayer(userid).get('lang')))

def player_hurt(ev):
	userid, attacker = int(ev['userid']), int(ev['attacker'])
	if playerlib.getPlayer(userid).get('isdead'):
		return

	if userid in Rb.rebels:
		return

	if userid in [LR.t, LR.ct] and attacker in [LR.t, LR.ct] and LR.lastrequest in LRM.overrides['player_hurt']:
		return

	if ev['weapon'] == str(sv('hosties_warning_weapon')):
		es.tell(userid, '#multi', text('warning shot', {'player': es.getplayername(attacker)}, playerlib.getPlayer(userid).get('lang')))
		playerlib.getPlayer(userid).set('health', playerlib.getPlayer(userid).get('health') + int(ev['dmg_health']) - int(sv('hosties_warning_weapon_damage')))
		if int(sv('hosties_warning_damage_regenerate')):
			gamethread.delayedname(int(sv('hosties_warning_damage_regenerate')), 'regen lost', check_regen, userid)
		return

	if attacker == LR.lrwinner and userid == LR.lrloser:
		return

	if Rb.check_rebel(userid):
		if int(sv('hosties_announce_attacked_with_gun')):
			HM.msg('attacked with gun', {'t': es.getplayername(userid), 'ct': es.getplayername(attacker)})
			return

	if es.getplayerteam(attacker) == 3 and es.getplayerteam(userid) == 2:
		if str(sv('hosties_announce_ct_hurt_t'))  == '0':
			return

		if str(sv('hosties_announce_ct_hurt_t')) == 'tell':
			es.tell(userid, '#multi', text('tell t attacked', {'player': es.getplayername(attacker)}, playerlib.getPlayer(userid).get('lang')))
		else:
			HM.msg('innocent attack', {'t': es.getplayername(userid), 'ct': es.getplayername(attacker)})

	if attacker in Rb.rebels:
		return

	if int(sv('hosties_rebel_on_hurt')):
		if es.getplayerteam(userid) == 3 and es.getplayerteam(attacker) == 2:
			if attacker == LR.t and not userid == LR.ct:
				LR.stopLR(None, None)
				getPlayer(attacker).makeRebel()

			elif not attacker == LR.t:
				if attacker in Rb.on_heads:
					return
				getPlayer(attacker).makeRebel()


def player_activate(ev):
	if int(sv('hosties_show_rules_on_join')):
		getPlayer(ev['userid']).send('Hosties')

	HM.getPlayer(ev['userid'])
	Rb.iks[int(ev['userid'])] = {}

def player_disconnect(ev):
	HM.delPlayer(ev['userid'])

def player_death(ev):
	Rb.player_death(int(ev['userid']), int(ev['attacker']), ev['weapon'])
	gamethread.delayed(0, LR.playerDeath, int(ev['userid']))

def player_jump(ev):
	gamethread.delayed(0.3, Rb.check_on_head, int(ev['userid']))
	CTRL.player_jump(int(ev['userid']))

def round_start(ev):
	LR.stopLR(None, None)
	del Rb.rebels[:]

	if int(sv('hosties_noblock_on_round_start')):
		for userid in es.getUseridList():
			es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 2)
		gamethread.delayedname(int(sv('hosties_noblock_on_round_start')), 'unblock', HM.unBlockPlayers)

def round_end(ev):
	for userid in es.getUseridList():
		if popuplib.isqueued('Punishment Menu', userid):
			popuplib.close('Punishement Menu', userid)

	for delay in ['unblock']:
		gamethread.cancelDelayed(delay)
	LR.stopLR(None, None)

def say_command():
	player_say({'userid': str(es.getcmduserid()), 'text': str('!' + es.getargv(0).replace('!', '')).replace('"', '')})

def player_say(ev):
	stext = ev['text'].lower()
	if stext in ['!lr', '!rules', '!checkplayers', '!commands', '!hosties', '!control', '!checkguns']:
		userid = int(ev['userid'])
		if not stext in str(sv('hosties_commands')):
			es.tell(userid, '#multi', text('disabled command', {}, playerlib.getPlayer(userid).get('lang')))
			return

		if stext == '!lr':
			LR.initiateRequest(userid)

		elif stext == '!rules':
			getPlayer(userid).send('Rules')

		elif stext == '!checkplayers':
			playermenu = popuplib.easymenu('Check Players', '_popup_choice', lambda *a: None)
			for userid2 in playerlib.getUseridList('#t,#alive'):
				playermenu.addoption(userid, ('[Rebel]' if userid2 in Rb.rebels else '[Non Rebel]') + ' %s'%es.getplayername(userid2))
			getPlayer(userid).send('Check Players')

		elif stext == '!commands':
			getPlayer(userid).send('Commands')

		elif stext == '!hosties':
			getPlayer(userid).send('Hosties')

		elif stext == '!control':
			if int(sv('hosties_enable_control')):
				if not es.getplayerteam(userid) == 3:
					es.tell(userid, '#multi', text('must be ct', {}, playerlib.getPlayer(userid).get('lang')))
					return
				getPlayer(userid).send('Control')

		elif stext == '!checkguns':
			gunmenu = popuplib.easymenu('Player Guns', '_popup_choice', gunmenu_select)
			for p in playerlib.getPlayerList('#t,#alive'):
				gunmenu.addoption(int(p), '%s [P: %s, S: %s]'%(p.get('name'), 'No' if p.get('primary') == '0' else 'Yes', 'No' if p.get('secondary') == '0' else 'Yes'))
			getPlayer(userid).send('Player Guns')

def player_spawn(ev):
	userid = ev['userid']
	if int(sv('hosties_strip_weapons_on_round_end')):
		es.server.queuecmd('es_xgive %s player_weaponstrip'%userid)
		es.server.queuecmd('es_xfire %s player_weaponstrip strip'%userid)
		es.server.queuecmd('es_delayed 0 es_fire %s player_weaponstrip kill'%userid)

	if es.getplayerteam(userid) == 2:
		for weapon in str(sv('hosties_t_start_weapons')).split(','):
			gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s weapon_%s'%(userid, weapon))

	elif es.getplayerteam(userid) == 3:
		if not str(sv('hosties_warning_weapon')) == '0':
			es.tell(userid, '#multi', text('warning weapon name', {'weapon': str(sv('hosties_warning_weapon'))}, playerlib.getPlayer(userid).get('lang')))

		for weapon in str(sv('hosties_ct_start_weapons')).split(','):
			gamethread.delayed(0, es.server.queuecmd, ('es_xgive %s weapon_%s'%(userid, weapon)))

	if int(sv('hosties_enable_noblock')):
		es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 2)

def item_pickup(ev):
	if HM.isRestricted(ev['item'], es.getplayerteam(ev['userid'])):
		handle = es.getplayerhandle(ev['userid'])
		for index in es.createentitylist('weapon_%s'%ev['item']):
			if handle == es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity'):
				es.server.queuecmd('es_xremove %s'%index)
				es.tell(ev['userid'], '#multi', text('restricted weapon', {'weapon': ev['item']}, playerlib.getPlayer(ev['userid']).get('lang')))
				es.cexec(ev['userid'], 'lastinv')
				break

### Commands ###

def lr_command():
	if es.getargv(0) in LRM.commands:
		LRM.commands[es.getargv(0)](es.getuserid())

def hosties_rule():
	args = es.getargs()
	if not args:
		es.dbgmsg(0, 'Need more args to add rules!')
		return
	HM.addRule(args)

def hosties_addpun():
	if es.getargs():
		if len(es.getargs().split(' ')) < 2:
			es.dbgmsg(0, 'Not enough arguments for hosties_addpunishment!')
			return
		Rb.add_punishment(es.getargs().split(' '))

def add_menu_punishment():
	if es.getargc() < 3:
		es.dbgmsg(0, 'Syntax Error: hosties_add_menu_punishment <kills> <punishments>')
		return

	args = es.getargs().split(' ')
	HM.punishments[args[0]] = args[1]

def hosties_load():
	gamethread.delayed(0, LRM.loadLastRequest, es.getargv(1))

def hosties_unload():
	gamethread.delayed(0, LRM.unloadLastRequest, es.getargv(1))

def hosties_reload():
	LRM.reloadLastRequest(es.getargv(1))

def _restrict_weapons(userid, args):
	if args[0].lower() in ['buy', 'jointeam', 'chooseteam']:
		if args[0].lower() == 'buy':
			if not args[1].lower() in (str(sv('hosties_unrestricted_ct_weapons')) if es.getplayerteam(userid) == 3 else str(sv('hosties_unrestricted_t_weapons'))):
				return False

		elif args[0].lower() in ['jointeam', 'chooseteam']:
			if args[1] == '0':
				es.tell(userid, '#multi', text('cant auto assign', {}, playerlib.getPlayer(userid).get('lang')))
				return False

			t_count = max(1, es.getplayercount(2))
			ct_count = max(1, es.getplayercount(3))

			if args[1] == '3':
				if es.getplayersteamid(userid) in Rb.trounds:
					es.tell(userid, '#multi', text('rounds as t', {'rounds': Rb.trounds[es.getplayersteamid(userid)]}, playerlib.getPlayer(userid).get('lang')))
					return False

				if ct_count - t_count >= int(sv('hosties_max_more_cts')):
					es.tell(userid, '#multi', text('too many ts', {}, playerlib.getPlayer(userid).get('lang')))
					return False

			ratio_str = str(es.ServerVar('hosties_t_to_ct_ratio')).replace(' ', '')
			if not ':' in ratio_str:
				return True

			ratio = map(int, ratio_str.split(':'))
			ratio = ratio[0] / float(ratio[1])

			if args[1] == '2':
				if float(t_count + 1) / max(1, ct_count - 1) > ratio * 2:
					es.tell(userid, '#multi', text('ratio unbalanced', {'ratio': ratio_str}, playerlib.getPlayer(userid).get('lang')))
					return False

			elif args[1] == '3':
				if max(1, t_count - 1) / float(ct_count + 1) < ratio / 2.0:
					es.tell(userid, '#multi', text('ratio unbalanced', {'ratio': ratio_str}, playerlib.getPlayer(userid).get('lang')))
					return False

	return LRM.returnClientCommand(userid, args)
es.addons.registerClientCommandFilter(_restrict_weapons)

### Popup Selects ###

def hosties_select(userid, choice, popupid):
	getPlayer(userid).send(choice)

def gunmenu_select(userid, choice, popupid):
	gunmenu = popuplib.easymenu('Current Guns', '_popup_choice', gunmenu_select)
	gunmenu.addoption(choice, 'Primary: %s'%playerlib.getPlayer(choice).get('primary'))
	gunmenu.addoption(choice, 'Secondary: %s'%playerlib.getPlayer(choice).get('secondary'))
	getPlayer(userid).send('Current Guns')

### Misc ###

def check_regen(userid):
	if not userid in Rb.rebels:
		if not playerlib.getPlayer(userid).get('isdead'):
			playerlib.getPlayer(userid).set('health', playerlib.getPlayer(userid).get('health') + int(sv('hosties_warning_weapon_damage')))

def getPlayer(userid):

	return HM.getPlayer(userid)