import hosties.hosties as hosties, es, gamethread, playerlib, random

LR = hosties.RegisterLastRequest('russianroulette')
sv = es.ServerVar

def unload():
	gamethread.cancelDelayed('view loop')

class RussianRoulette(object):
	def __init__(self):
		self.t = None
		self.ct = None

		self.shots_fired = 0
		self.noisy = False

	def start(self, t, ct):
		[es.set('hosties_' + x, 0) for x in 'xyz']
		x, y, z = playerlib.getPlayer(t).get('viewangle')
		es.server.queuecmd('es_xsetang %s 90 %s 0'%(t, y))

		es.server.queuecmd('est_getviewcoord %s hosties_x hosties_y hosties_z'%t)
		gamethread.delayed(0, self.checkValidCoords, (t, ct))

	def checkValidCoords(self, t, ct):
		x, y, z = [float(sv('hosties_' + w)) for w in 'xyz']
		x2, y2, z2 = es.getplayerlocation(t)

		if (((x - x2) ** 2) + ((y - y2) ** 2)) ** 0.5 <= 100:
			hosties.getPlayer(t).tell('not enough space roulette')
			return
		self.validRequest(t, ct)

	def validRequest(self, t, ct):
		self.t = t
		self.ct = ct

		hosties.HM.msg('roulette', {'t': es.getplayername(t), 'ct': es.getplayername(ct)})
		hosties.HM.msg('roulette start')

		for userid in [t, ct]:
			playerlib.getPlayer(userid).set('health', 1124)
			playerlib.getPlayer(userid).set('freeze', 1)

			es.server.queuecmd('es_xgive %s player_weaponstrip'%userid)
			es.server.queuecmd('es_xfire %s player_weaponstrip strip'%userid)
		es.delayed(0, 'es_xfire %s player_weaponstrip kill'%userid)

		x, y, z = playerlib.getPlayer(t).get('viewvector')
		x2, y2, z2 = es.getplayerlocation(t)

		es.server.queuecmd('es_xsetpos %s %s %s %s'%(ct, x2 + (x * 75), y2 + (y * 75), z2))
		es.delayed(0.1, 'es_xgive %s weapon_deagle'%random.choice([t, ct]))

		es.doblock('corelib/noisy_on')
		self.noisy = True

		self.setViewLoop()

	def setViewLoop(self):
		if not self.t:
			return

		for userid in [(self.t, self.ct), (self.ct, self.t)]:
			playerlib.getPlayer(userid[0]).set('viewplayer', userid[1])
		gamethread.delayedname(0.5, 'view loop', self.setViewLoop)

	def end(self):
		for userid in [self.t, self.ct]:
			if not userid:
				continue

			player = playerlib.getPlayer(userid)
			if player.get('isdead'):
				continue

			player.set('health', 100)
			player.set('freeze', 0)

		self.t = None
		self.ct = None

		if self.noisy:
			es.doblock('corelib/noisy_off')
			self.noisy = False

	def fireWeapon(self, userid, weapon):
		userid = int(userid)
		if not userid in [self.t, self.ct]:
			return

		if not random.randint(0, 6 - self.shots_fired):
			es.server.queuecmd('damage %s 1125 32 %s'%(self.t if userid == self.ct else self.ct, userid))
			return LR.stopLR(userid, 'won rr', {'player': es.getplayername(userid)})

		self.shots_fired += 1
		playerlib.getPlayer(userid).set('viewplayer', self.t if userid == self.ct else self.ct)

		if es.getplayersteamid(userid) == 'BOT':
			es.sexec(userid, 'drop')
			return
		es.cexec(userid, 'drop')

	def playerDeath(self, userid, attacker, weapon):
		if userid in [self.t, self.ct] and attacker in [self.t, self.ct]:
			return
		hosties.getPlayer(attacker).checkKill(userid, weapon)

	def playerHurt(self, userid, attacker, weapon):
		if playerlib.getPlayer(userid).get('isdead'):
			return

		if userid in [self.t, self.ct] and attacker in [self.t, self.ct]:
			if not weapon == 'deagle':
				LR.stopLR(userid, 'rr gun', {'player': es.getplayername(attacker)})
				if attacker == self.t:
					hosties.getPlayer(attacker).makeRebel()
				return
			playerlib.getPlayer(userid).set('health', 1124)

RR = RussianRoulette()

def player_hurt(ev):
	RR.playerHurt(int(ev['userid']), int(ev['attacker']), ev['weapon'])

def player_death(ev):
	RR.playerDeath(int(ev['userid']), int(ev['attacker']), ev['weapon'])

def weapon_fire(ev):
	RR.fireWeapon(ev['userid'], ev['weapon'])

def round_end(ev):
	if RR.noisy:
		es.doblock('corelib/noisy_off')
		RR.noisy = False

LR.registerStartFunction(RR.start)
LR.registerEndFunction(RR.end)
LR.registerOverRide('player_hurt')
